// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UObject.h"

#include <memory>
#include <string>

using std::wstring;

namespace Sourcify
{	
	class ISCW_UMetaData : public virtual ISCW_UObject
	{
	public:
		virtual ~ISCW_UMetaData() = default;

		virtual std::shared_ptr<ISCW_UMetaData> ToUMetaDataPtr() = 0;
		virtual std::shared_ptr<const ISCW_UMetaData> ToUMetaDataConstPtr() const = 0;

		virtual wstring GetValue(ISCW_UObjectConstPtr Object, const wstring& Key) const = 0;

		virtual void SetValue(ISCW_UObjectPtr Object, const wstring& Key, const wstring& Value) = 0;
	};

	using ISCW_UMetaDataConstPtr = std::shared_ptr<const ISCW_UMetaData>;
	using ISCW_UMetaDataPtr = std::shared_ptr<ISCW_UMetaData>;
} // namespace Sourcify